#include "stdlib.h"
#include "string.h"
#include "project.h"

#define dimDelay 10u
#define rStep   10

uint8 rxadd, rxcmd, rxcnt, rxchk, rxchksm, rxtemp1;
uint8 m1, task1;
uint8 rdata[255];

uint16 l1, temp, blink = 0;                                 //logic variable
uint16 ls1;                                                 //dimmer variable
uint16 ds1, ds2;                                            //dimmer variable
uint8 s1;                                                   //saved logic
uint8 sls1, sls2;                                           //saved dimmer
uint16 tt1;                                                 //touch lock variable
uint16 white1, recall, z1;                                  //white LED, Recall, Temp variable
uint16 save_rom = 0;

uint16 ir_add = 0x01;                                       //IR remote address variable
uint16 ir_1 = 0x50;                                         //IR remote button 1 variable                                           //IR remote button variable
uint16 ir_2 = 0xD8;                                         //IR remote button 2 variable
uint16 ir_3 = 0xF8;                                         //IR remote button 3 variable
uint16 ir_4 = 0x30;                                         //IR remote button 4 variable
uint16 ir_5 = 0xB0;                                         //IR remote button 5 variable
uint16 ir_6 = 0x70;                                         //IR remote button 6 variable
uint16 ir_7 = 0xD0;                                         //IR remote button 7 variable
uint16 ir_f = 0x72;                                         //IR remote button F variable
uint16 ir_u = 0x92;                                         //IR remote button U variable
uint16 ir_d = 0xB2;                                         //IR remote button D variable

uint16 ir_m1 = 0xC8;                                        //IR remote button M1 variable
uint16 ir_m2 = 0x08;                                        //IR remote button M2 variable

uint16 ir_sn1 = 0x42;                                       //IR remote button S1 variable
uint16 ir_sn2 = 0xC2;                                       //IR remote button S2 variable
uint16 ir_sn3 = 0x22;                                       //IR remote button S3 variable
uint16 ir_sn4 = 0xA2;                                       //IR remote button S4 variable
uint16 ir_sn5 = 0x62;                                       //IR remote button S5 variable
uint16 ir_sn6 = 0xE2;                                       //IR remote button S6 variable

uint8 address = 0, invaddress = 0;                          //IR obtained address
uint8 command = 0, invcommand = 0;                          //IR obtained command
uint16 flag0, flag1, flagm, flaginc = 0;                    //IR execution variables
uint16 i = 0, j, k, p[68], b, x, y, z;                      //IR execution variables
uint16 ir_mmd;                                              //IR memory chk variables
uint8 ir_chksm;                                             //IR checksum variables

uint16 sn1 = 0,   sn11 = 0, sn1s1 = 1;                      //Scene S1 Variables
uint16 sn2 = 0,   sn21 = 0, sn2s1 = 1;                      //Scene S2 Variables
uint16 sn3 = 0,   sn31 = 0, sn3s1 = 1;                      //Scene S3 Variables
uint16 sn4 = 0,   sn41 = 0, sn4s1 = 1;                      //Scene S4 Variables
uint16 sn5 = 0,   sn51 = 0, sn5s1 = 1;                      //Scene S5 Variables
uint16 sn6 = 0,   sn61 = 0, sn6s1 = 1;                      //Scene S6 Variables

uint16 t_count = 0, t_number = 0;

#define len 29
static const uint8 CYCODE eepromArray[len]__attribute__ ((section(".MY_SECTION1"))) =
{ 0,                                      //ON-OFF status of variable l1...
  0, 0,                                   //Speed status of variable ls1...,White LED
  0, 0, 0,                                //Scene S1 Variables
  0, 0, 0,                                //Scene S2 Variables
  0, 0, 0,                                //Scene S3 Variables
  0, 0, 0,                                //Scene S4 Variables
  0, 0, 0,                                //Scene S5 Variables
  0, 0, 0,                                //Scene S6 Variables
  0x72, 0x92, 0xB2,                       //IR button default data
  0, 0, 0xC8, 0x08,                       //Recall, Checksum IR, Master, Mute
  0                                      //Lock Data
};
uint8 Pin_Status[len];                    //Temporary data stored for EEPROM
uint8 Pin_Clear[len];

void save_fun() {
  if (save_rom == 1) {
    ISR_IR_Disable();
    ISR_UART_Disable();

    Pin_Status[0] = l1;
    Pin_Status[1] = ls1;

    Pin_Status[2] = white1;

    Pin_Status[3] = sn1;
    Pin_Status[4] = sn11;
    Pin_Status[5] = sn1s1;

    Pin_Status[6] = sn2;
    Pin_Status[7] = sn21;
    Pin_Status[8] = sn2s1;

    Pin_Status[9] = sn3;
    Pin_Status[10] = sn31;
    Pin_Status[11] = sn3s1;

    Pin_Status[12] = sn4;
    Pin_Status[13] = sn41;
    Pin_Status[14] = sn4s1;

    Pin_Status[15] = sn5;
    Pin_Status[16] = sn51;
    Pin_Status[17] = sn5s1;

    Pin_Status[18] = sn6;
    Pin_Status[19] = sn61;
    Pin_Status[20] = sn6s1;

    Pin_Status[21] = ir_f;
    Pin_Status[22] = ir_u;
    Pin_Status[23] = ir_d;

    Pin_Status[24] = recall;
    Pin_Status[25] = ir_chksm;
    Pin_Status[26] = ir_m1;
    Pin_Status[27] = ir_m2;

    Pin_Status[28] = tt1;

    Em_EEPROM_Write(Pin_Status, eepromArray, len);
    ISR_IR_Enable();
    ISR_UART_Enable();
    save_rom = 0;
  }
}

void ledUpdate() {
  CyDelay(10u);
  if (l1 % 2 == 1) {
    if (ls1 > 90)   {
      G_1_Write(0u);
      W_1_Write(1u);
      G_2_Write(1u);
      W_2_Write(0u);
    }   else if (ls1 < 11)  {
      G_1_Write(1u);
      W_1_Write(0u);
      G_2_Write(0u);
      W_2_Write(1u);
    }   else    {
      G_1_Write(1u);
      W_1_Write(0u);
      G_2_Write(1u);
      W_2_Write(0u);
    }
  }  else    {
    G_1_Write(0u);  W_1_Write(1u);  G_2_Write(0u);  W_2_Write(1u);
  }
}

void status_1()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xF4);
  UART_UartPutChar(0x04);
  UART_UartPutChar(0x01);
  UART_UartPutChar(l1 % 2);
  UART_UartPutChar(ls1);
  UART_UartPutChar(0x04 + 0x01 + l1 % 2 + ls1);
  CyDelay(100u);
}

void onoff_1()
{
  if (l1 % 2 == 1)
  {
    if (ls1 > 90)      {
      ls1 = 100;
      G_1_Write(0u);
      W_1_Write(1u);
      G_2_Write(1u);
      W_2_Write(0u);
    }
    else if (ls1 < 11) {
      ls1 = 10;
      G_1_Write(1u);
      W_1_Write(0u);
      G_2_Write(0u);
      W_2_Write(1u);
    }
    else            {
      G_1_Write(1u);
      W_1_Write(0u);
      G_2_Write(1u);
      W_2_Write(0u);
    }

      if (ls1 > 0 && ls1 <= 10)      ds1 = 3800;
      if (ls1 > 10 && ls1 <= 20)     ds1 = 4100;
      if (ls1 > 20 && ls1 <= 30)     ds1 = 4400;
      if (ls1 > 30 && ls1 <= 40)     ds1 = 4700;
      if (ls1 > 40 && ls1 <= 50)     ds1 = 5000;
      if (ls1 > 50 && ls1 <= 60)     ds1 = 5300;
      if (ls1 > 60 && ls1 <= 70)     ds1 = 5600;
      if (ls1 > 70 && ls1 <= 80)     ds1 = 5900;
      if (ls1 > 80 && ls1 <= 90)     ds1 = 6200;
      if (ls1 > 90 && ls1 <= 100)    ds1 = 9500;

    if (ds2 == 0)                   // Slow dimmer start
    {
      PWM_Start();
      for (x = ds2; x < ds1; x++) // ds1=11000 & ds2=0, dimmer count goes from 0 to 11000
      {
        PWM_WriteCompare(x);
        CyDelayUs(dimDelay);
      }
    }
    else
    {
      if (ds2 < ds1)              // Blink Up LED
      {
        G_1_Write(~G_1_Read());
        W_1_Write(~W_1_Read());
        CyDelay(50u);
        G_1_Write(~G_1_Read());
        W_1_Write(~W_1_Read());
      }
      if (ds1 < ds2)              // Blink Down LED
      {
        G_2_Write(~G_2_Read());
        W_2_Write(~W_2_Read());
        CyDelay(50u);
        G_2_Write(~G_2_Read());
        W_2_Write(~W_2_Read());
      }
      for (x = ds2; x < ds1; x++) // Slow dimmer increase upto 3000 count diff. means 39 ms
      {
        PWM_WriteCompare(x);
        CyDelayUs(dimDelay);
      }
      for (x = ds2; x > ds1; x--) // Slow dimmer decrease upto 3000 count diff. means 39 ms
      {
        PWM_WriteCompare(x);
        CyDelayUs(dimDelay);
      }
    }
    ds2 = ds1;
  }
  if (l1 % 2 == 0)            // Slow turn off Dimmer
  {
    for (x = ds2; x > 0; x--)
    {
      PWM_WriteCompare(x);
      CyDelayUs(dimDelay);
    }
    PWM_Stop();
    ds2 = 0;
    G_1_Write(0u);  W_1_Write(1u);  G_2_Write(0u);  W_2_Write(1u);
  }
}

void status_all()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xF3);
  UART_UartPutChar(0x03);
  UART_UartPutChar(l1 % 2);
  UART_UartPutChar(ls1);
  UART_UartPutChar(0x03 + l1 % 2 + ls1);
}

void onoff_all()
{
  if (tt1 % 2 == 0)   {
    onoff_1();
    CyDelay(1u);
  }
  status_all();
}

void master_onoff()
{
  switch (((tt1 % 2 == 0) ? l1 % 2 : 0))
  {
    case 0:
      if (tt1 % 2 == 0)   {
        l1 = s1;
        ls1 = sls1;
      }
      s1 = 0;
      break;

    case 1:
      s1 = l1;
      if (tt1 % 2 == 0)   {
        l1 = 0;
        sls1 = ls1;
      }
      break;

    default:
      break;
  }
  if (((tt1 % 2 == 0) ? l1 % 2 : 0) | s1 % 2)
  {
    onoff_all();
  }
  else
  {
    UART_UartPutChar(0xB4);
    UART_UartPutChar(0xF9);
    UART_UartPutChar(0x01);
    UART_UartPutChar(0x01);
  }
}

void white_status()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xFB);
  UART_UartPutChar(0x02);
  UART_UartPutChar(white1 % 2);
  UART_UartPutChar(0x02 + white1 % 2);
}

void recall_status()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xFC);
  UART_UartPutChar(0x02);
  UART_UartPutChar((recall + 1) % 2);
  UART_UartPutChar(0x02 + (recall + 1) % 2);
}

void white_led()
{
  if (white1 % 2 == 1)
  {
    W_1_SetDriveMode(W_1_DM_OD_LO);
    W_2_SetDriveMode(W_2_DM_OD_LO);
  }
  if (white1 % 2 == 0)
  {
    W_1_SetDriveMode(W_1_DM_STRONG);
    W_2_SetDriveMode(W_2_DM_STRONG);
  }
  white_status();
  save_rom = 1;
}

void io_onoff(uint8 m1)
{
  switch (m1)
  {
    case 0x01:
      l1 = rdata[2];
      ls1 = rdata[3];
      onoff_1();
      break;

    default:
      break;
  }
}

void onoff_ack()
{
  if (task1 == 1)
  {
    task1 = 0;
    UART_UartPutChar(0xB4);
    UART_UartPutChar(0xF1);
    UART_UartPutChar(0x02);
    UART_UartPutChar(0x00);
    UART_UartPutChar(0x02);
  }
  else
  {
    task1 = 0;
    UART_UartPutChar(0xB4);
    UART_UartPutChar(0xF1);
    UART_UartPutChar(0x02);
    UART_UartPutChar(0xFF);
    UART_UartPutChar(0x01);
  }
}

void node_details()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xF5);
  UART_UartPutChar(0x03);
  UART_UartPutChar(0x00);
  UART_UartPutChar(0x01);
  UART_UartPutChar(0x04);
}

void lock_status()
{
  UART_UartPutChar(0xB4);
  UART_UartPutChar(0xFA);
  UART_UartPutChar(0x02);
  UART_UartPutChar((tt1 + 1) % 2);
  UART_UartPutChar(0x02 + (tt1 + 1) % 2);
}

void rx_action()
{
  switch (rxcmd)
  {
    case 0x01:
      io_onoff(rdata[1]);
      task1 = 1;
      onoff_ack();
      break;

    case 0x02:
      if (tt1 % 2 == 0)
      {
        l1 = rdata[1];
        ls1 = rdata[2];
      }
      onoff_all();
      task1 = 1;
      onoff_ack();
      break;

    case 0x03:
      status_all();
      break;

    case 0x04:
      if (rdata[1] == 0x01)
      {
        status_1();
      }
      break;

    case 0x05:
      node_details();
      break;

    case 0x06:
      if (rdata[1] == 0x01)  {
        tt1 = rdata[2] + 1;
      }
      lock_status();
      task1 = 1;
      onoff_ack();
      break;

    case 0x07:
      G_1_Write(~G_1_Read());
      W_1_Write(~W_1_Read());
      CyDelay(250u);
      task1 = 1;
      onoff_ack();
      break;

    case 0x08:
      if (rdata[1] == 0x01)
      {
        white1 = rdata[2];
        white_led();
      }
      if (rdata[1] == 0x02)
      {
        recall = rdata[2] + 1;
        recall_status();
      }
      task1 = 1;
      onoff_ack();
      save_rom = 1;
      break;

    case 0x09:
      for (int i = 0; i < len; i++) {
        Pin_Clear[i] = 0;
      }
      ISR_IR_Disable();
      ISR_UART_Disable();

      Em_EEPROM_Write(Pin_Clear, eepromArray, len);

      ISR_IR_Enable();
      ISR_UART_Enable();
      CyDelay(5u);
      CySoftwareReset();
      break;

    case 0x0A:
      lock_status();
      break;

    case 0x0B:
      white_status();
      break;

    case 0x0C:
      recall_status();
      break;

    case 0x0D:

      break;

    case 0x0E:
      UART_UartPutChar(0xB4);
      UART_UartPutChar(0xFE);
      UART_UartPutChar(0x01);
      UART_UartPutChar(0x01);
      CyDelay(5u);
      //CySoftwareReset();
      break;

    case 0x0F:
      UART_UartPutChar(0xB4);
      UART_UartPutChar(0xFF);
      UART_UartPutChar(0x01);
      UART_UartPutChar(0x01);
      break;

    default:
      break;
  }
  ledUpdate();
  save_rom = 1;
}

void rx_decode()
{
  CyDelay(1u);
  rxadd = UART_UartGetByte();
  if (rxadd == 0xB4)
  {
    CyDelay(1u);
    rxcmd = UART_UartGetByte();
    CyDelay(1u);
    rxcnt = UART_UartGetByte();
    if (rxcnt != 0)
    {
      rxchksm = rxcnt;
      rdata[0] = rxcnt;
      for (k = 1; k < rxcnt; k++)
      {
        CyDelay(1u);
        rxtemp1 = UART_UartGetByte();
        rdata[k] = rxtemp1;
        rxchksm = rxchksm + rxtemp1;
      }
      CyDelay(1u);
      rxchk = UART_UartGetByte();
      if (rxchk == rxchksm)
      {
        rx_action();
      }
      else
      {
        memset(rdata, 0, rxcnt);
        UART_UartPutChar(0xB4);
        UART_UartPutChar(0xF1);
        UART_UartPutChar(0x02);
        UART_UartPutChar(0x77);
        UART_UartPutChar(0x79);
      }
      rxchksm = 0;
    }
    save_rom = 1;
  }
}

CY_ISR(ISRUART)
{
  ISR_UART_Disable();
  rx_decode();
  UART_ClearRxInterruptSource(UART_INTR_RX_NOT_EMPTY);
  ISR_UART_Enable();
}

void get_scene()
{
  if ((address == ir_add) && ((command + invcommand) == 0xFF))
  {
    if (command == ir_sn1)   {
      sn1++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn11 = s1;
      sn1s1 = sls1;
    }
    if (command == ir_sn2)   {
      sn2++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn21 = s1;
      sn2s1 = sls1;
    }
    if (command == ir_sn3)   {
      sn3++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn31 = s1;
      sn3s1 = sls1;
    }
    if (command == ir_sn4)   {
      sn4++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn41 = s1;
      sn4s1 = sls1;
    }
    if (command == ir_sn5)   {
      sn5++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn51 = s1;
      sn5s1 = sls1;
    }
    if (command == ir_sn6)   {
      sn6++;
      s1 = l1 + 1;
      sls1 = ls1;
      sn61 = s1;
      sn6s1 = sls1;
    }

    if (command == ir_m1)    {
      recall++;
      recall_status();
    }

    if (command == ir_f)   if (tt1 % 2) {
        l1++;
        onoff_1();
        status_1();
      }
    if (command == ir_u)   if (tt1 % 2) {
        if (l1 % 2)    {
          ls1 += rStep;
          onoff_1();
          status_1();
        }
      }
    if (command == ir_d)   if (tt1 % 2) {
        if (l1 % 2)    {
          ls1 -= rStep;
          onoff_1();
          status_1();
        }
      }
  }
}

void changeIR()
{
  if ((address == ir_add) && ((command + invcommand) == 0xFF))
  {
    switch (t_number)
    {
      case 1:
        if (command == ir_m1)
        {
          tt1++;
          lock_status();
        }
        else if (command == ir_m2)
        {
          ir_f = 0xB4;
          ir_u = 0xB4;
          ir_d = 0xB4;
        }
        else
        {
          ir_f = command;
          if (ir_f == 0x38)
          {
            ir_u = 0x80;
            ir_d = 0x10;
          }
          if (ir_f == 0x88)
          {
            ir_u = 0x20;
            ir_d = 0x90;
          }
          if (ir_f == 0x72)
          {
            ir_u = 0x92;
            ir_d = 0xB2;
          }
          if (ir_f == 0xD2)
          {
            ir_u = 0x52;
            ir_d = 0x32;
          }
          if (ir_f == 0xC0)
          {
            ir_u = 0xF0;
            ir_d = 0x82;
          }
          if (ir_f == 0xE0)
          {
            ir_u = 0xD0;
            ir_d = 0x02;
          }
          if (ir_f == 0x40)
          {
            ir_u = 0x70;
            ir_d = 0x60;
          }
          if (ir_f == 0x98)
          {
            ir_u = 0xB0;
            ir_d = 0xA0;
          }
        }
        break;

      case 8:
        get_scene();
        if (command == ir_m2) {
          for (int i = 0; i < len; i++) {
            Pin_Clear[i] = 0;
          }
          ISR_IR_Disable();
          ISR_UART_Disable();

          Em_EEPROM_Write(Pin_Clear, eepromArray, len);

          ISR_IR_Enable();
          ISR_UART_Enable();
          CyDelay(5u);
          CySoftwareReset();
        }
        break;

      default:
        break;
    }
    ir_chksm = ir_f + ir_u + ir_d + ir_m1 + ir_m2;
    blink = 0;
    save_rom = 1;
    ledUpdate();
  }
}

void shiftIR()
{
  for (b = 0; b < 40; b++)
  {
    if (blink == 1) {
      G_1_Write(1u);
      G_2_Write(1u);
      W_1_Write(0u);
      W_2_Write(0u);
      CyDelay(100u);
      G_1_Write(0u);
      G_2_Write(0u);
      W_1_Write(1u);
      W_2_Write(1u);
      CyDelay(100u);
    }
  }
  blink = 0;
  ledUpdate();
}

void ir_check()
{
  if ((address == ir_add) && ((command + invcommand) == 0xFF))
  {
    if (command == ir_f)   if (tt1 % 2 == 0) {
        l1++;
        onoff_1();
        status_1();
      }
    if (command == ir_u)   if (tt1 % 2 == 0) {
        if (l1 % 2)    {
          if (ls1 < 91) {
            ls1 += rStep;
            onoff_1();
            status_1();
          }
        }
      }
    if (command == ir_d)   if (tt1 % 2 == 0) {
        if (l1 % 2)    {
          if (ls1 > 11) {
            ls1 -= rStep;
            onoff_1();
            status_1();
          }
        }
      }
    if (command == ir_m1)  {
      master_onoff();
    }
    if (command == ir_m2)  {
      white1++;
      white_led();
    }
    if (command == ir_sn1) {
      if (sn1 % 2 == 1) {
        l1 = sn11;
        ls1 = sn1s1;
        onoff_1();
        status_1();
      }
    }
    if (command == ir_sn2) {
      if (sn2 % 2 == 1) {
        l1 = sn21;
        ls1 = sn2s1;
        onoff_1();
        status_1();
      }
    }
    if (command == ir_sn3) {
      if (sn3 % 2 == 1) {
        l1 = sn31;
        ls1 = sn3s1;
        onoff_1();
        status_1();
      }
    }
    if (command == ir_sn4) {
      if (sn4 % 2 == 1) {
        l1 = sn41;
        ls1 = sn4s1;
        onoff_1();
        status_1();
      }
    }
    if (command == ir_sn5) {
      if (sn5 % 2 == 1) {
        l1 = sn51;
        ls1 = sn5s1;
        onoff_1();
        status_1();
      }
    }
    if (command == ir_sn6) {
      if (sn6 % 2 == 1) {
        l1 = sn61;
        ls1 = sn6s1;
        onoff_1();
        status_1();
      }
    }
    save_rom = 1;
  }
  address = 0; invaddress = 0; command = 0; invcommand = 0;   b = 36;
}

void analyze(void)
{
  if ((p[1] > 140) && (p[1] < 200))
  {
    if ((p[2] > 70) && (p[2] < 100))
    {
      {
        for (j = 4; j < 19; j++)
        {
          {
            if (p[j] > 20)
              address = ((address << 1) + 1);
            else
              address = ((address << 1) + 0);
          }
          j = j + 1;
        }
      }
      {
        for (j = 20; j < 35; j++)
        {
          if (p[j] > 20)
            invaddress = ((invaddress << 1) + 1);
          else
            invaddress = ((invaddress << 1) + 0);

          j = j + 1;
        }
      }
      {
        for (j = 36; j < 51; j++)
        {
          if (p[j] > 20)
            command = ((command << 1) + 1);
          else
            command = ((command << 1) + 0);

          j = j + 1;
        }
      }
      {
        for (j = 52; j < 67; j++)
        {
          if (p[j] > 20)
            invcommand = ((invcommand << 1) + 1);
          else
            invcommand = ((invcommand << 1) + 0);

          j = j + 1;
        }
      }
    }
  }
}

CY_ISR(ISRIR)
{
  ISR_IR_Disable();
  ISR_UART_Disable();
  IR_ClearInterrupt();
  if (i == 0)
  {
    Timer_1_Start();
  }
  if ((i > 0) && (i < 68))
  {
    p[i] = Timer_1_ReadCounter();
    if (Timer_1_ReadCounter() > 400)   i = 0;
    Timer_1_WriteCounter(0);
  }
  i++;
  if (i == 67)   analyze();
  if (i > 67)    i = 0;
  ISR_IR_Enable();
  if (t_count > 0xB4)     changeIR();
  ir_check();
  ISR_UART_Enable();
}

void cap_check()
{
  CapSense_UpdateEnabledBaselines();
  CapSense_ScanEnabledWidgets();
  while (CapSense_IsBusy() != 0) {}
  if (CapSense_CheckIsAnyWidgetActive())
  {
    if (CapSense_CheckIsWidgetActive(CapSense_P_F__BTN))
    {
      while (CapSense_CheckIsAnyWidgetActive())
      {
        t_count++;
        CapSense_UpdateEnabledBaselines();
        CapSense_ScanEnabledWidgets();
        while (CapSense_IsBusy() != 0) {
          ;
        }
      }
      if (tt1 % 2 == 0) {
        l1++;
        onoff_1();
        status_1();
      }
      t_number = 8;
    }
    if (CapSense_CheckIsWidgetActive(CapSense_P_U__BTN))
    {
      while (CapSense_CheckIsAnyWidgetActive())
      {
        t_count++;
        CapSense_UpdateEnabledBaselines();
        CapSense_ScanEnabledWidgets();
        while (CapSense_IsBusy() != 0) {
          ;
        }
      }
      t_number = 1;
      if (tt1 % 2 == 0) {
        if (l1 % 2)    {
          ls1 += rStep;
          onoff_1();
        }
      }

      status_1();
      save_rom = 1;
      ledUpdate();
    }
    if (CapSense_CheckIsWidgetActive(CapSense_P_D__BTN))
    {
      while (CapSense_CheckIsAnyWidgetActive())
      {
        t_count++;
        CapSense_UpdateEnabledBaselines();
        CapSense_ScanEnabledWidgets();
        while (CapSense_IsBusy() != 0) {
          ;
        }
      }
      t_number = 1;
      if (tt1 % 2 == 0) {
        if (l1 % 2)    {
          ls1 -= rStep;
          onoff_1();
        }
      }
      status_1();
      save_rom = 1;
      ledUpdate();
    }
    if ((t_count > 0xB4) && (t_number != 0))
    {
      blink = 1;
      shiftIR();
    }
    t_count = t_number = 0;
  }
}

int main(void)
{
  CyGlobalIntEnable;
  CapSense_Start();
  CapSense_InitializeAllBaselines();

  UART_Start();
  Em_EEPROM_Start();
  ISR_IR_StartEx(ISRIR);
  ISR_UART_StartEx(ISRUART);
  CyDelay(100u);

  sn1 = ((*(volatile uint8 *)&eepromArray[3]));
  sn11 = ((*(volatile uint8 *)&eepromArray[4]));
  sn1s1 = ((*(volatile uint8 *)&eepromArray[5]));

  sn2 = ((*(volatile uint8 *)&eepromArray[6]));
  sn21 = ((*(volatile uint8 *)&eepromArray[7]));
  sn2s1 = ((*(volatile uint8 *)&eepromArray[8]));

  sn3 = ((*(volatile uint8 *)&eepromArray[9]));
  sn31 = ((*(volatile uint8 *)&eepromArray[10]));
  sn3s1 = ((*(volatile uint8 *)&eepromArray[11]));

  sn4 = ((*(volatile uint8 *)&eepromArray[12]));
  sn41 = ((*(volatile uint8 *)&eepromArray[13]));
  sn4s1 = ((*(volatile uint8 *)&eepromArray[14]));

  sn5 = ((*(volatile uint8 *)&eepromArray[15]));
  sn51 = ((*(volatile uint8 *)&eepromArray[16]));
  sn5s1 = ((*(volatile uint8 *)&eepromArray[17]));

  sn6 = ((*(volatile uint8 *)&eepromArray[18]));
  sn61 = ((*(volatile uint8 *)&eepromArray[19]));
  sn6s1 = ((*(volatile uint8 *)&eepromArray[20]));

  ir_f = ((*(volatile uint8 *)&eepromArray[21]));
  ir_u = ((*(volatile uint8 *)&eepromArray[22]));
  ir_d = ((*(volatile uint8 *)&eepromArray[23]));

  ir_m1 = ((*(volatile uint8 *)&eepromArray[26]));
  ir_m2 = ((*(volatile uint8 *)&eepromArray[27]));

  ir_chksm = ir_f + ir_u + ir_d + ir_m1 + ir_m2;
  ir_mmd = ((*(volatile uint8 *)&eepromArray[25]));

  if ((ir_chksm != ir_mmd) | (ir_m1 != 0xC8) | (ir_m2 != 0x08))
  {
    ir_1 = 0x50;
    ir_2 = 0xD8;
    ir_3 = 0xF8;
    ir_4 = 0x30;
    ir_5 = 0xB0;
    ir_6 = 0x70;
    ir_7 = 0xD0;
    ir_f = 0x72;
    ir_u = 0x92;
    ir_d = 0xB2;
    ir_m1 = 0xC8;
    ir_m2 = 0x08;
  }

  white1 = ((*(volatile uint8 *)&eepromArray[2]));
  recall = ((*(volatile uint8 *)&eepromArray[24]));
  tt1 = ((*(volatile uint8 *)&eepromArray[28]));

  white_led();

  if (tt1 % 2)    {
    l1 = ((*(volatile uint8 *)&eepromArray[0]));
    ls1 = ((*(volatile uint8 *)&eepromArray[1]));
    onoff_1();
  } else {
    if (recall % 2)
    {
      l1 = ((*(volatile uint8 *)&eepromArray[0]));
      ls1 = ((*(volatile uint8 *)&eepromArray[1]));
      onoff_1();
    } else {
      l1 = 0;
      ls1 = 0;
      onoff_1();
    }
  }

  node_details();
  CyDelay(100u);
  recall_status();
  CyDelay(100u);
  lock_status();

  for (;;)
  {
    cap_check();
    save_fun();
  }
}

/* [] END OF FILE */